#gawk script to extract connectivity from RE_gp
#
#WBL 21 July 2004 created $Revision: 1.1 $"
#http://www.cs.ucl.ac.uk/staff/W.Langdon/lisp2dot.html

#WBL 23 July 2008 adapt for use with syntax.awk REs
#assume syntax.awk run first

#example 
#gawk -f syntax.awk -f RE_gp2dot.awk syntax.txt RE_gp.out16 >! ~/t.dot
#~/graphviz/bin/dot -Gsize="10.0,6.25" -Grotate=90 -Tps t.dot > ! t.ps

#dot file documentation http://www.graphviz.org/cgi-bin/man?dot
#dot interpreter http://java.ist.unomaha.edu/~payne/dot/

BEGIN { 
}

(FNR==1) {
  printf("//Created by RE_gp2dot.awk %s",substr("$Revision: 1.1 $",2));
  printf(" from file %s\n",FILENAME);
}

($3=="<start>" && $1=="#") {
  n1=index($0,"<start>");
  code = substr($0,n1);
}

END{
  check(); #syntax.txt
  l=split(code,inst," ");
  printf("#'%s'\n",code);
  printf("#%d4",l);for(i=1;i<=l;i++) printf("'%s'",inst[i]);printf("\n");
# print code;
  print "digraph simpleDotFile {";
  l=split(code,inst," ");
  pc=0;
  parent=-1;
  args=1; #sanity check only
  for(i=1;i<=l;i++) {
    if(length(inst[i])>0) {
      node_name[pc]=inst[i];
      node_nxt[pc]=0;
      node_arity[pc]=arity_(node_name[pc]);
      args += node_arity[pc]-1;
#      printf("//i=%3d pc=%3d %2d %d %2d %20s %3d\n",    \
#	     i,                                          \
#	     pc,                                         \
#	     arity_(node_name[pc]),			 \
#	     node_arity[pc],                             \
#	     args,					 \
#	     sprintf(",%s,",node_name[pc]),              \
#	     parent);

      if(args<0) {print "ERROR badly formed tree. Check arity1-4? args",args," i=",i," pc=",pc,inst[i];
	  exit 1;
      }
      node_back[pc]=parent;
      node_nxt[parent]++;
      node_child[parent,node_nxt[parent]]=pc;
      if(node_arity[pc]>0) parent=pc;
      else {
	for(j=parent; node_nxt[j]>=node_arity[j] && j>=0; ){
	  j=node_back[j];
	  parent=j;
#	  printf("//j=%3d parent=%3d\n",j,parent);
	}
      }
      pc++;
    }
  }
  if(args!=0) print "ERROR2 badly formed tree. Check arity1-4? args",args," i=",i," pc=",pc,inst[i];
  print_label(0);
  for(p=0;p<pc;p++) {
      for(i=1;i<=node_arity[p];i++) {
	  q=node_child[p,i];
	  print_label(q);
	  printf("%s -> %s;\n",id(p),id(q));
      }
  }
  print "}";
}

function print_label(pc, n,t,s) {
    n=split(node_name[pc],t,"\"")
    s=(n<2)? node_name[pc] : t[2];
    if(s=="$") s=""; #$ is not an empty symbol!
    printf("%s [label=\"%s\"",id(pc),s);
    if(!(node_name[pc] in rule_l && node_name[pc] in rule_r))
	printf(",shape=none");
    printf("];\n");
}
function id(pc) {
    return sprintf("n%03d",pc);	     
}

function arity_(symbol, t) {
  return (symbol in rule)? split(rule[symbol],t) : 
         (symbol in rule_l || symbol in rule_r)? 1 : 0;
}