#WBL 19 April 2008 based on stats.awk r1.2 $Revision: 1.4 $
#WBL 16 April 2008 based on random_syntax r1.16

function command_options(program_name) {
  if(seed=="") seed=151922;
  srand(seed);
  if(pPopSize=="")       pPopSize=100;
  if(pMaxExpr=="")       pMaxExpr=25;
  if(pMinInitExpr=="")   pMinInitExpr=2;
  if(pInitExpr=="")      pInitExpr   =6;
  if(min_hairpin=="")    min_hairpin=3;
  if(min_stem=="")       min_stem=3;
  longexpression=pMaxExpr;
  largedepth=pInitExpr;
  print "#"program_name,"seed="seed,
    "pMaxExpr="pMaxExpr,
    "pMinInitExpr="pMinInitExpr,
    "pInitExpr="pInitExpr,
    "pPopSize="pPopSize,
    min_hairpin,min_stem,
    strftime();
}

(FNR==1) {file++; check();}

(file==1 && index($0,"#")!=1 && NF>1 && ($1 in rule || $1 in rule_l || $1 in rule_r)) {
  print "ERROR repeated rule definition line",FNR,$1,rule[$1],rule_l[$1];
  exit;
}


(file==1 && index($0,"#")!=1 && NF>1) {
#  arity[$1] = (index($0,"|"))? 2 : 0;
  arity[$1] = ($4=="|")? 2 : 0;
  if(arity[$1]) {
    if(NF!=5) {printf("ERROR too many components for binary rule %s\n",$0)> "/dev/stderr";exit;}
    rule_l[$1] = $3;
    rule_r[$1] = $5;
  } else {
    for(i=3;i<=NF;i++) rule[$1] = sprintf("%s %s",rule[$1],$i);
  }
  if("$"==$3) shorter[$1] = 0;
  else if("$"==$5) shorter[$1] = 1;
  else if(index($1,"RE")) shorter[$1] = 1; #Heuristic for RE syntax
  else if($1=="<E>")      shorter[$1] = 0; #Heuristic for sin syntax
}

function check( r,n,t,i,k,kk,j,nkk) {
  for(r in rule_l) check_rule(r,1);
  for(r in rule_r) check_rule(r,2);
  for(r in rule) {
    n=split(rule[r],t);
    if(n==0) {printf("ERROR missing rule definition '%s'\n",r)> "/dev/stderr";exit;}
    for(i=1;i<=n;i++){
      k=t[i];
#     print r,n,i,k;
      if(k in rule_l || k in rule_r) {
	check_rule(k,1);
	check_rule(k,2);
      }
      else if(index(k,"'")==length(k)) {
#	printf("WARNING complementary definitions no longer in use %s in rule %s\n",k,r)> "/dev/stderr";
	kk = substr(k,1,length(k)-1);
	nkk=0; for(j=1;j<i;j++) if(t[j]==kk) nkk++;
        if(nkk!=1) {printf("ERROR %d complementary definitions of %s in rule %s\n",nkk,k,r)> "/dev/stderr";exit;}
      }
      else if(!(k in rule)) check_term(k);
    }
  }
}
function element(array,I) {
  if(I in array) return array[I];
  return "";
}

function check_rule(r,a,  k) {
  k = (a==1)? element(rule_l,r) : element(rule_r,r);
# printf("check_rule(%s,%d) -> %s\n",r,a,k) > "/dev/stderr";
  if(length(r)<2||index(r,"\"")==1) check_term(r);
  else {
  if(a==1 && (!(r in rule_r))){printf("ERROR missing rule_r[%s]\n",r)       > "/dev/stderr";exit;}
  if(a==2 && (!(r in rule_l))){printf("ERROR missing rule_l[%s]\n",r)       > "/dev/stderr";exit;}
  if(length(k)<2||index(k,"\"")==1) check_term(k);
  else if(!(k in rule||k in rule_l)){printf("ERROR rule '%s' missing '%s'\n",r,k)>"/dev/stderr";exit;}
  }
}
function check_term(t) {
# printf("check_term(%s)\n",t) > "/dev/stderr";
  if(length(t)!=1&&index(t,"\"")!=1) {printf("ERROR terminal too long '%s'\n",t)> "/dev/stderr";exit;}
}

#bit of a hack, gives max possible number of bases
#Also ignores possiblity of already reversed
function count(s1,s2, i,c,s,m) {
  c=0;s="";m=0;
  for(i in stack) delete stack[i]; SP=0;
  for(i=s1;i<=s2;i++) {
#   s=sprintf("%s%s",s,pheno[i]);
    if(index("ATCGNPp",pheno[i])) c++;
    else if(index(pheno[i],"|")) {m=max(m,c);c=top();}
    else if(index(pheno[i],"(")) push(m);
    else if(index(pheno[i],")")) m=c=max(max(m,c),pop());
  }
  m=max(m,c);
# printf("count(%s,%s '%s') %d\n",s1,s2,s,m);
  return m;
}
function max(a,b) {
  return (a>b)? a : b;
}
function top()   {return stack[SP];}
function push(x) {stack[++SP]=x;}
function pop(x)  {return stack[SP--];}


function complement(s) {
  if(s=="T") return "A";
  if(s=="A") return "T";
  if(s=="C") return "G";
  if(s=="G") return "C";
  if(s=="P") return "p";
  if(s=="p") return "P"; 
  if(s=="\".\"") return "\".\""; 
  if(s=="\"(\"") return "\")\""; 
  if(s=="\")\"") return "\"(\""; 
  if(s=="\"[\"") return "\"]\""; 
  if(s=="\"]\"") return "\"[\""; 
  if(s=="\"[^\"") return "\"]\""; #best that can be done
  #"*" "+" "^" "$" 
  return ""; #s;
}

function assert(true,id) {
  if(!true) {
    printf("ERROR assert %s failed\n",id,FILENAME) > "/dev/stderr";
    exit;
  }
}

function print_prog(  j,n,t,s) {
    printf(" ");
    for(j=0;j<=PC;j++) printf("%s ",prog[j]);
    printf("\n");
    printf("egrep -c -v '");
    for(j=0;j<pPC;j++) {
      n=split(pheno[j],t,"\"")
      s=(n<2)? pheno[j] : t[2];
      printf("%s",(s=="$")? "\\$" : s); #escape $ to avoid cshell problems
    }
    printf("' $1 $2\n");
}

function rnd(d) { return int(d*rand()); }

#DO "ramped half and half from pMinInitExpr to pInitExpr"
function random_program( d) {
    PC=0; pPC=0;
  prog[PC] = "<start>"
  #choose max depth
  d = rnd(pInitExpr-pMinInitExpr)+pMinInitExpr;
  #choose full or half full
  #go to depth=d
  SubInit(1,d,rnd(2),pMinInitExpr); 
}

#globals IP,tree
function treenode(ip,prog, nxt) {
  nxt = element(prog,ip+1);
  #printf("treenode(%d,prog) '%s' '%s' '%s' '%s'",
  #	 ip,prog[ip],nxt,
  #	 element(rule_l,prog[ip]),element(rule_r,prog[ip]));
  if(prog[ip] in rule_l || prog[ip] in rule_r) {
    tree[++IP] = (nxt==element(rule_r,prog[ip]));
    #printf(" tree[%d]=%s\n",IP,tree[IP]);
    assert(nxt==element(rule_l,prog[ip]) || 
	   nxt==element(rule_r,prog[ip]),"treenode");
  } #else printf(" tree[%d]=%s\n",IP,tree[IP]);

}
function traverse(ip,prog,global,
		  args,n,t) {
  args = 1;
  while (args > 0) {
    n=(prog[ip] in rule)? split(rule[prog[ip]],t) : 
      (prog[ip] in rule_l || prog[ip] in rule_r)? 1 : 0;
    args=args+n-1;
    if(global) treenode(ip,prog); #may set globals IP,tree
    ip++;
  }
  return ip;
}

#Initialize a subtree half full, assumed binary!
#global ip=PC
function SubInit(argstogo,depth,isfull, mindepth, #depth refers only to branch nodes
		 i,maxargs,
                 r,n,t,save,j,J,c1,c2) {
  r = prog[PC];
# printf("%s %s SubInit(%s,%s,%s,%s)\n",r,PC,argstogo,depth,isfull, mindepth)    > "/dev/stderr";
  if(r in rule) {#Expand rule (no choices to be made)
    n=split(rule[r],t);
    for(i=1;i<=n;i++) {
      prog[++PC]=t[i];
      save=pPC;
      SubInit(argstogo+n-1,depth,isfull, mindepth);
      # 'complement not in use
      #J=0; for(j=i+1;j<=n && J==0;j++) if(sprintf("%s'",t[i])==t[j]) J=1;
      #if(J) save_pPC[depth]=sprintf("%d_%d",save,pPC);
      #if(J) printf(" save_pPC[%d]<-%s ",depth,save_pPC[depth]);
    }
  }
  else if(r in rule_l && r in rule_r) {
    #calculate max number of args there is space to add. 
    maxargs = pMaxExpr -(PC+argstogo);
    #keep going regardless assert(maxargs>=0); #can sometimes trip this WBL    
#terminal required
    if (maxargs == 0 || depth <= 0 )
      i=(r in shorter)? shorter[r] : int(rand()+0.5);
#node required
    else if (isfull || mindepth>0)
      i=(maxargs<2 && r in shorter)? shorter[r] : int(rand()+0.5);
#terminal allowed 50% of the time
    else if (rnd(2)) #terminal required
      i=(r in shorter)? shorter[r] : int(rand()+0.5);
    else #node required
      i=(r in shorter)? (!shorter[r]) : int(rand()+0.5);

    prog[++PC] = (i==0)? rule_l[r] : rule_r[r];
    SubInit(argstogo+1-1,depth-1,isfull, mindepth-1);
  }
#special for complementary DNA sequences
  else if(index(r,"'")==length(r)) {
    assert(0,"complementary DNA sequences noy in use");
    split(save_pPC[depth],t,"_");
    c1=count(t[1],t[2]-1);
    c2=count(t[2],pPC-1);
    if(c1 >=min_hairpin && c2>=min_stem) {
      #printf(" {reversing '%s' %d %d:",save_pPC[depth],pPC,depth);
      for(i=t[2]-1;i>=t[1];--i) {
	pheno[pPC++]=complement(pheno[i]);
	#printf("%s",complement(pheno[i]));
      }
      #printf("gnisrever}\n");
    }
  }
#terminal of grammar
  else if(r!="$") {
    #tidy up {} quantifiers for egrep. Ensure second is not less than first
    if(r=="\"{\"") {
      current_int = 0;
      first_sep = 0;
    }
    else if(r=="\",\"") {
      first_int   = current_int;
      first_sep   = pPC;
      current_int = 0;
    }
    else if(r=="\"}\"") {
      if(first_sep!=0 && current_int<first_int) pPC = first_sep;
    }
    else if(n=index("0123456789",r)) current_int=current_int*10+(n-1);
    pheno[pPC++]=r;
    #printf("%s",r);
  }
}

END{
  check();
}

#Create subtree using choices recorded in tree
#globals IP, tree
#        PC, prog
function SubInit_(argstogo,depth, #depth refers only to nodes with choices
		 i,maxargs,
                 r,n,t,save,j,J,c1,c2) {
  if(depth<0 || PC>pMaxExpr) return 0;
  r = prog[PC];
  #printf("%s %s SubInit(%s,%s)\n",r,PC,argstogo,depth);#    > "/dev/stderr";
  #printf("PC=%d,r='%s' %s %s %s\n",PC,r,r in rule,r in rule_l,r in rule_r);

  if(r in rule) {#Expand rule (no choices to be made)
    n=split(rule[r],t);
    for(i=1;i<=n;i++) {
      prog[++PC]=t[i];
      save=pPC;
      if(SubInit_(argstogo+n-1,depth)==0) return 0;
      # 'complement not in use
      #J=0; for(j=i+1;j<=n && J==0;j++) if(sprintf("%s'",t[i])==t[j]) J=1;
      #if(J) save_pPC[depth]=sprintf("%d_%d",save,pPC);
      #if(J) printf(" save_pPC[%d]<-%s ",depth,save_pPC[depth]);
    }
  }
  else if(r in rule_l && r in rule_r) {
    #printf("PC=%d,r='%s'\n",PC,r);
    #calculate max number of args there is space to add. 
    maxargs = pMaxExpr -(PC+argstogo);
    #keep going regardless assert(maxargs>=0); #can sometimes trip this WBL    
    #assert(++IP in tree,"SubInit_");
    ++IP;
    if(!(IP in tree)){print " SubInit_ failed IP=",IP,r,tree[IP-1] > "/dev/stderr"; exit 1;}
    prog[++PC] = (tree[IP]==0)? rule_l[r] : rule_r[r];
    if(SubInit_(argstogo+1-1,depth-1)==0) return 0;
  }
#special for complementary DNA sequences
  else if(index(r,"'")==length(r)) {
    assert(0,"complementary DNA sequences noy in use");
    split(save_pPC[depth],t,"_");
    c1=count(t[1],t[2]-1);
    c2=count(t[2],pPC-1);
    if(c1 >=min_hairpin && c2>=min_stem) {
      #printf(" {reversing '%s' %d %d:",save_pPC[depth],pPC,depth);
      for(i=t[2]-1;i>=t[1];--i) {
	pheno[pPC++]=complement(pheno[i]);
	#printf("%s",complement(pheno[i]));
      }
      #printf("gnisrever}\n");
    }
  }
#terminal of grammar
  else if(r!="$") {
    #tidy up {} quantifiers for egrep. Ensure second is not less than first
    if(r=="\"{\"") {
      current_int = 0;
      first_sep = 0;
    }
    else if(r=="\",\"") {
      first_int   = current_int;
      first_sep   = pPC;
      current_int = 0;
    }
    else if(r=="\"}\"") {
      if(first_sep!=0 && current_int<first_int) pPC = first_sep;
    }
    else if(n=index("0123456789",r)) current_int=current_int*10+(n-1);
    pheno[pPC++]=r;
    #printf("%s",r);
  }
  return 1;#ok
}

